; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "ModShell"
!define PRODUCT_VERSION "0.1alpha2"
!define PRODUCT_PUBLISHER "Pozsar Zsolt"
!define PRODUCT_WEB_SITE "http://www.pozsarzs.hu"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\modshell.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

; Language Selection Dialog Settings
!define MUI_LANGDLL_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_LANGDLL_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_LANGDLL_REGISTRY_VALUENAME "NSIS:Language"

; Uninstaller pages
!insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_LICENSE "$(MUILicense)" 
!insertmacro MUI_PAGE_COMPONENTS
!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_INSTFILES
!define MUI_FINISHPAGE_RUN "$INSTDIR\modshell.exe"
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_WELCOME
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES
!insertmacro MUI_UNPAGE_FINISH

; Language files
!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_LANGUAGE "Hungarian"

; License Language
LicenseLangString MUILicense ${LANG_ENGLISH} "modshell\LICENCE"
LicenseLangString MUILicense ${LANG_HUNGARIAN} "modshell\LICENCE"

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "modshell-0.1alpha2-win64.exe"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show

Function .onInit
  !insertmacro MUI_LANGDLL_DISPLAY
  StrCpy $InstDir "$PROGRAMFILES64\ModShell"
FunctionEnd

Section "Main files" SEC01
  SetOutPath "$INSTDIR\document"
  SetOverwrite try
  File "modshell\document\authors"
  File "modshell\document\changelog"
  File "modshell\document\copyright"
  File "modshell\document\install"
  File "modshell\document\modbus.txt"
  File "modshell\document\readme"
  File "modshell\document\version"
  SetOutPath "$INSTDIR\document\example"
  File "modshell\document\example\addition.bat"
  File "modshell\document\example\copyset1.bat"
  File "modshell\document\example\copyset2.bat"
  File "modshell\document\example\for-if.bat"
  File "modshell\document\example\getdt510.bat"
  File "modshell\document\example\getpm9c.bat"
  File "modshell\document\example\setdt510.bat"
  SetOutPath "$INSTDIR"
  File "modshell\modshell.exe"
  File "modshell\licence"
  File "modshell\readme.md"
  CreateShortCut "$DESKTOP\ModShell.lnk" "$INSTDIR\modshell.exe"
  CreateDirectory "$SMPROGRAMS\ModShell"
  CreateShortCut "$SMPROGRAMS\ModShell\ModShell.lnk" "$INSTDIR\modshell.exe"
SectionEnd

Section "Translate HU" SEC02
  SetOutPath "$INSTDIR\message\hu"
  File "modshell\message\hu\modshell.mo"
  File "modshell\message\hu\modshell.po"
  SetOutPath "$INSTDIR\message"
  File "modshell\message\modshell.pot"
SectionEnd

Section -AdditionalIcons
  SetOutPath $INSTDIR
  CreateDirectory "$SMPROGRAMS\ModShell"
  CreateShortCut "$SMPROGRAMS\ModShell\Uninstall.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\modshell.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\modshell.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd

; Section descriptions
  LangString DESC_Section1 ${LANG_ENGLISH} "Required files"
  LangString DESC_Section2 ${LANG_ENGLISH} "Hungarian translate"
  LangString DESC_Section1 ${LANG_HUNGARIAN} "K�telez� �llom�nyok"
  LangString DESC_Section2 ${LANG_HUNGARIAN} "Magyar ford�t�s"
  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC01} $(DESC_Section1)
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC02} $(DESC_Section2)
  !insertmacro MUI_FUNCTION_DESCRIPTION_END

; Section uninstall
  Function un.onInit
  !insertmacro MUI_UNGETLANGUAGE
  FunctionEnd

Section Uninstall
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\readme.md"
  Delete "$INSTDIR\licence"
  Delete "$INSTDIR\modshell.exe"
  Delete "$INSTDIR\message\modshell.pot"
  Delete "$INSTDIR\message\hu\modshell.po"
  Delete "$INSTDIR\message\hu\modshell.mo"
  Delete "$INSTDIR\document\example\addition.bat"
  Delete "$INSTDIR\document\example\copyset1.bat"
  Delete "$INSTDIR\document\example\copyset2.bat"
  Delete "$INSTDIR\document\example\for-if.bat"
  Delete "$INSTDIR\document\example\getdt510.bat"
  Delete "$INSTDIR\document\example\getpm9c.bat"
  Delete "$INSTDIR\document\example\setdt510.bat"
  Delete "$INSTDIR\document\authors"
  Delete "$INSTDIR\document\changelog"
  Delete "$INSTDIR\document\copyright"
  Delete "$INSTDIR\document\install"
  Delete "$INSTDIR\document\readme"
  Delete "$INSTDIR\document\modbus.txt"
  Delete "$INSTDIR\document\version"
  Delete "$SMPROGRAMS\ModShell\Uninstall.lnk"
  Delete "$DESKTOP\ModShell.lnk"
  Delete "$SMPROGRAMS\ModShell\ModShell.lnk"
  RMDir "$SMPROGRAMS\ModShell"
  RMDir "$INSTDIR\message\hu"
  RMDir "$INSTDIR\message"
  RMDir "$INSTDIR\document\example"
  RMDir "$INSTDIR\document"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd
